<?php

class russianLanguageSupport
{
	public function declinate($nom, $case)
	{
		if (!$word=Words::model()->findByAttributes(array('nom'=>$nom)))
		{
			$word= new Words;
			
			// Building Request URL
			$url = 'http://export.yandex.ru/inflect.xml?name='.urlencode($nom);

			// Processing CURL Request
			$curl = curl_init( $url );
			curl_setopt( $curl, CURLOPT_USERAGENT, 'Opera/9.80 (Windows NT 6.1; U; ru) Presto/2.6.30 Version/10.61' ); // Just for fun, or ...
			curl_setopt( $curl, CURLOPT_RETURNTRANSFER, 1 );
			$result = curl_exec( $curl );
			curl_close( $curl );
					
			// Preparing Inflections
			$cases = array ();
			preg_match_all( '#\<inflection\s+case\=\"([0-9]+)\"\>(.*?)\<\/inflection\>#si', $result, $m );
			
			// Creating Inflection List
			if ( count($m[0]) ) 
			{
				foreach ( $m[1] as $i => &$id ) {
					$cases[ (int) $id ] = $m[2][$i];
				} unset ( $id );
				$word->nom=(isset($cases[1]))?$cases[1]:$nom;
				$word->gen=(isset($cases[2]))?$cases[2]:$nom;
				$word->dat=(isset($cases[3]))?$cases[3]:$nom;
				$word->acc=(isset($cases[4]))?$cases[4]:$nom;
				$word->str=(isset($cases[5]))?$cases[5]:$nom;
				$word->prep=(isset($cases[6]))?$cases[6]:$nom;
			}
			else
			{
				$word->nom=$nom;
				$word->gen=$nom;
				$word->dat=$nom;
				$word->acc=$nom;
				$word->str=$nom;
				$word->prep=$nom;
			}
			$word->save();
			
		}
		return $word->$case;
	}
}